with GAda.Text_IO ;
with INSA_Air;
with Train;
with Avion_Sol;
with Assert;

procedure Mission2b is


   --
   -- Mission 2, partie 1 : fonction Delta_Cap
   --
   -- Cette fonction Delta_Cap est incorrecte.
   -- À vous de corriger son algorithme.
   --
   function Delta_Cap(Cap_Actuel : Float ; Cap_Voulu : Float) return Float is
      Ecart_Angle : Float ;
	 
   begin
      Ecart_Angle := Cap_Voulu - Cap_Actuel ;

      if Ecart_Angle < -180.0 then
         Ecart_Angle := Ecart_Angle + 360.0 ;
      end if ;
      if Ecart_Angle > 180.0 then
	 Ecart_Angle := Ecart_Angle -360.0;
      end if;

      return Ecart_Angle ;
   end Delta_Cap ;

   
   --
   -- Mission 2, partie 1 : procédure de test de Delta_Cap
   -- 
   -- Cette procédure est incomplète, à vous de la rendre utile.
   --
   procedure Tester_Delta_Cap(CapA : Float ; CapV : Float) is
      Ecart_Angle: Float;
   begin
      Ecart_Angle := Delta_Cap(Cap_Actuel => CapA, Cap_Voulu => CapV);
      GAda.Text_IO.Put_Line (Aff => "Le cap actuel vaut" & Float'Image(CapA) & " Le cap Voulut vaut:" & Float'Image(CapV) & " Delta Cap vaut:" & Float'Image(Ecart_Angle)) ;
   end Tester_Delta_Cap ;
 
   --
   -- Mission 2, partie 2 : fonction Caps_Egaux
   function Caps_Egaux(Cap1:Float; Cap2:Float) return Boolean is
      Dif_Cap: Float;
   begin
      Dif_Cap:= abs((Delta_Cap(Cap1 , Cap2)));
      return Dif_Cap <= 5.0;
   end Caps_Egaux;
   
   
   --
   -- Mission 2, partie 2 : procédure de test de Caps_Egaux
   procedure Tester_Caps_Egaux(Cap1: Float; Cap2: Float) is
      Rep: Boolean;
   begin
      Rep := Caps_Egaux(Cap1 , Cap2);
      GAda.Text_IO.Put_Line(Aff => "Ecart:" & Boolean'Image(Rep));
   end Tester_Caps_Egaux;
   
   --
   -- Mission 2, parties 1 et 2 : réalisation de plusieurs tests
   --
   procedure Tests_Unitaires is
   begin
      Tester_Delta_Cap (CapA => 0.0,   CapV => 45.0) ;
      Tester_Delta_Cap (CapA => 45.0,  CapV => 0.0) ;
      Tester_Delta_Cap (CapA => 350.0, CapV => 10.0) ;
      Tester_Delta_Cap (CapA => 10.0,  CapV => 350.0) ;
      Tester_Delta_Cap (CapA => 30.0,  CapV => 285.0) ;
      Tester_Delta_Cap (CapA => 178.0,  CapV => 182.0) ;
      Tester_Caps_Egaux(Cap1 => 0.0,   Cap2 => 5.0) ;
      Tester_Caps_Egaux(Cap1 => 2.0,  Cap2 => 359.0) ;
      Tester_Caps_Egaux(Cap1 => 350.0, Cap2 => 10.0) ;
      Tester_Caps_Egaux(Cap1 => 10.0,  Cap2 => 350.0) ;
      Tester_Caps_Egaux(Cap1 => 178.0,  Cap2 => 182.0) ;
      
      -- Ajouter vos propres tests unitaires
   end Tests_Unitaires ;
   

   --
   -- Mission 2, partie 3 : procédure Orienter_au_sol
   procedure Orienter_Au_Sol(Cap: Float) is
      Cap_Bon: Boolean;
      Delt_Cap: Float;
   begin
      Cap_Bon:= (Cap < 0.0) or (Cap > 360.0);
      Assert.Failif(Cap_Bon , "Le cap demandé ne correspond pas aux attentes");
      INSA_Air.Regler_Reacteur(1);
      while not Caps_Egaux(Cap , INSA_Air.Cap_Courant) loop
	 Delt_Cap:= Delta_Cap(INSA_Air.Cap_Courant , Cap);
	 if Delt_Cap <0.0 then
	    Train.Positionner_A_Gauche;
	 elsif Delt_Cap = 0.0 then
	    Train.Positionner_A_Zero;
	 else
	    Train.Positionner_A_Droite;
	 end if;
	 INSA_Air.Attendre(0.05);
      end loop;
      Avion_Sol.Freiner;
    end Orienter_Au_Sol;
	 
      
   --
   
   
   --
   -- Mission 2, partie 3 : procédure Tester_Cap
   --
    procedure Tester_Cap is
    begin
       Avion_Sol.Rouler_Vers('L');
       Avion_Sol.Rouler_Vers('M');
       Avion_Sol.Freiner;
       Avion_Sol.Attendre_Entree;
       Mission2b.Orienter_Au_Sol(0.0);
       Avion_Sol.Attendre_Entree;
       Mission2b.Orienter_Au_Sol(90.0);
       Avion_Sol.Attendre_Entree;
       Mission2b.Orienter_Au_Sol(270.0);
       Avion_Sol.Attendre_Entree;
       Mission2b.Orienter_Au_Sol(180.0);
       Avion_Sol.Attendre_Entree;
       Avion_Sol.Rouler_Vers('L');
       Avion_Sol.Rouler_Vers('K');
       
   end Tester_Cap;
   --
   -- Mission 2, partie 4 : procédure Orienter_en_vol
   --
   
   
   --
   -- Mission 2, partie 4 : procédure Realiser_Vol_Demo
   --


begin
   
   -- Effectuer tous les tests unitaires de Delta_Cap et Caps_Egaux
   Tests_Unitaires ;
   Tester_Cap;

end Mission2b ;
